

import std.stdio;
import std.string;

enum D_DIK_ESCAPE       = 0x01;
enum D_DIK_1            = 0x02;
enum D_DIK_2            = 0x03;
enum D_DIK_3            = 0x04;
enum D_DIK_4            = 0x05;
enum D_DIK_5            = 0x06;
enum D_DIK_6            = 0x07;
enum D_DIK_7            = 0x08;
enum D_DIK_8            = 0x09;
enum D_DIK_9            = 0x0A;
enum D_DIK_0            = 0x0B;
enum D_DIK_MINUS        = 0x0C;
enum D_DIK_EQUALS       = 0x0D;
enum D_DIK_BACK         = 0x0E;
enum D_DIK_TAB          = 0x0F;
enum D_DIK_Q            = 0x10;
enum D_DIK_W            = 0x11;
enum D_DIK_E            = 0x12;
enum D_DIK_R            = 0x13;
enum D_DIK_T            = 0x14;
enum D_DIK_Y            = 0x15;
enum D_DIK_U            = 0x16;
enum D_DIK_I            = 0x17;
enum D_DIK_O            = 0x18;
enum D_DIK_P            = 0x19;
enum D_DIK_LBRACKET     = 0x1A;
enum D_DIK_RBRACKET     = 0x1B;
enum D_DIK_RETURN       = 0x1C;
enum D_DIK_LCONTROL     = 0x1D;
enum D_DIK_A            = 0x1E;
enum D_DIK_S            = 0x1F;
enum D_DIK_D            = 0x20;
enum D_DIK_F            = 0x21;
enum D_DIK_G            = 0x22;
enum D_DIK_H            = 0x23;
enum D_DIK_J            = 0x24;
enum D_DIK_K            = 0x25;
enum D_DIK_L            = 0x26;
enum D_DIK_SEMICOLON    = 0x27;
enum D_DIK_APOSTROPHE   = 0x28;
enum D_DIK_GRAVE        = 0x29;
enum D_DIK_LSHIFT       = 0x2A;
enum D_DIK_BACKSLASH    = 0x2B;
enum D_DIK_Z            = 0x2C;
enum D_DIK_X            = 0x2D;
enum D_DIK_C            = 0x2E;
enum D_DIK_V            = 0x2F;
enum D_DIK_B            = 0x30;
enum D_DIK_N            = 0x31;
enum D_DIK_M            = 0x32;
enum D_DIK_COMMA        = 0x33;
enum D_DIK_PERIOD       = 0x34;
enum D_DIK_SLASH        = 0x35;
enum D_DIK_RSHIFT       = 0x36;
enum D_DIK_MULTIPLY     = 0x37;
enum D_DIK_LMENU        = 0x38;
enum D_DIK_SPACE        = 0x39;
enum D_DIK_CAPITAL      = 0x3A;
enum D_DIK_F1           = 0x3B;
enum D_DIK_F2           = 0x3C;
enum D_DIK_F3           = 0x3D;
enum D_DIK_F4           = 0x3E;
enum D_DIK_F5           = 0x3F;
enum D_DIK_F6           = 0x40;
enum D_DIK_F7           = 0x41;
enum D_DIK_F8           = 0x42;
enum D_DIK_F9           = 0x43;
enum D_DIK_F10          = 0x44;
enum D_DIK_NUMLOCK      = 0x45;
enum D_DIK_SCROLL       = 0x46;
enum D_DIK_NUMPAD7      = 0x47;
enum D_DIK_NUMPAD8      = 0x48;
enum D_DIK_NUMPAD9      = 0x49;
enum D_DIK_SUBTRACT     = 0x4A;
enum D_DIK_NUMPAD4      = 0x4B;
enum D_DIK_NUMPAD5      = 0x4C;
enum D_DIK_NUMPAD6      = 0x4D;
enum D_DIK_ADD          = 0x4E;
enum D_DIK_NUMPAD1      = 0x4F;
enum D_DIK_NUMPAD2      = 0x50;
enum D_DIK_NUMPAD3      = 0x51;
enum D_DIK_NUMPAD0      = 0x52;
enum D_DIK_DECIMAL      = 0x53;
enum D_DIK_OEM_102      = 0x56;
enum D_DIK_F11          = 0x57;
enum D_DIK_F12          = 0x58;
enum D_DIK_F13          = 0x64;
enum D_DIK_F14          = 0x65;
enum D_DIK_F15          = 0x66;
enum D_DIK_KANA         = 0x70;
enum D_DIK_ABNT_C1      = 0x73;
enum D_DIK_CONVERT      = 0x79;
enum D_DIK_NOCONVERT    = 0x7B;
enum D_DIK_YEN          = 0x7D;
enum D_DIK_ABNT_C2      = 0x7E;
enum D_DIK_NUMPADEQUALS = 0x8D;
enum D_DIK_PREVTRACK    = 0x90;
enum D_DIK_AT           = 0x91;
enum D_DIK_COLON        = 0x92;
enum D_DIK_UNDERLINE    = 0x93;
enum D_DIK_KANJI        = 0x94;
enum D_DIK_STOP         = 0x95;
enum D_DIK_AX           = 0x96;
enum D_DIK_UNLABELED    = 0x97;
enum D_DIK_NEXTTRACK    = 0x99;
enum D_DIK_NUMPADENTER  = 0x9C;
enum D_DIK_RCONTROL     = 0x9D;
enum D_DIK_MUTE         = 0xA0;
enum D_DIK_CALCULATOR   = 0xA1;
enum D_DIK_PLAYPAUSE    = 0xA2;
enum D_DIK_MEDIASTOP    = 0xA4;
enum D_DIK_VOLUMEDOWN   = 0xAE;
enum D_DIK_VOLUMEUP     = 0xB0;
enum D_DIK_WEBHOME      = 0xB2;
enum D_DIK_NUMPADCOMMA  = 0xB3;
enum D_DIK_DIVIDE       = 0xB5;
enum D_DIK_SYSRQ        = 0xB7;
enum D_DIK_RMENU        = 0xB8;
enum D_DIK_PAUSE        = 0xC5;
enum D_DIK_HOME         = 0xC7;
enum D_DIK_UP           = 0xC8;
enum D_DIK_PRIOR        = 0xC9;
enum D_DIK_LEFT         = 0xCB;
enum D_DIK_RIGHT        = 0xCD;
enum D_DIK_END          = 0xCF;
enum D_DIK_DOWN         = 0xD0;
enum D_DIK_NEXT         = 0xD1;
enum D_DIK_INSERT       = 0xD2;
enum D_DIK_DELETE       = 0xD3;
enum D_DIK_LWIN         = 0xDB;
enum D_DIK_RWIN         = 0xDC;
enum D_DIK_APPS         = 0xDD;
enum D_DIK_POWER        = 0xDE;
enum D_DIK_SLEEP        = 0xDF;
enum D_DIK_WAKE         = 0xE3;
enum D_DIK_WEBSEARCH    = 0xE5;
enum D_DIK_WEBFAVORITES = 0xE6;
enum D_DIK_WEBREFRESH   = 0xE7;
enum D_DIK_WEBSTOP      = 0xE8;
enum D_DIK_WEBFORWARD   = 0xE9;
enum D_DIK_WEBBACK      = 0xEA;
enum D_DIK_MYCOMPUTER   = 0xEB;
enum D_DIK_MAIL         = 0xEC;
enum D_DIK_MEDIASELECT  = 0xED;

enum D_DIK_BACKSPACE    = D_DIK_BACK;
enum D_DIK_NUMPADSTAR   = D_DIK_MULTIPLY;
enum D_DIK_LALT         = D_DIK_LMENU;
enum D_DIK_CAPSLOCK     = D_DIK_CAPITAL;
enum D_DIK_NUMPADMINUS  = D_DIK_SUBTRACT;
enum D_DIK_NUMPADPLUS   = D_DIK_ADD;
enum D_DIK_NUMPADPERIOD = D_DIK_DECIMAL;
enum D_DIK_NUMPADSLASH  = D_DIK_DIVIDE;
enum D_DIK_RALT         = D_DIK_RMENU;
enum D_DIK_UPARROW      = D_DIK_UP;
enum D_DIK_PGUP         = D_DIK_PRIOR;
enum D_DIK_LEFTARROW    = D_DIK_LEFT;
enum D_DIK_RIGHTARROW   = D_DIK_RIGHT;
enum D_DIK_DOWNARROW    = D_DIK_DOWN;
enum D_DIK_PGDN         = D_DIK_NEXT;
class KeyTable {
static :
	private int[string] NameTable;
	this() {
		NameTable = [
			 "KEY_BACK"		: D_DIK_BACK,		/// バックスペースキー
			 "KEY_TAB"		: D_DIK_TAB,		/// タブキー
			 "KEY_RETURN" : D_DIK_RETURN,	/// エンターキー

			 "KEY_LSHIFT"	 : D_DIK_LSHIFT,		/// 左シフトキー
			 "KEY_RSHIFT"	 : D_DIK_RSHIFT,		/// 右シフトキー
			 "KEY_LCONTROL" : D_DIK_LCONTROL,	/// 左コントロールキー
			 "KEY_RCONTROL" : D_DIK_RCONTROL,	/// 右コントロールキー
			 "KEY_ESCAPE"	 : D_DIK_ESCAPE,		/// エスケープキー
			 "KEY_SPACE"	 : D_DIK_SPACE,			/// スペースキー
			 "KEY_PGUP"		 : D_DIK_PGUP,			/// ＰａｇｅＵＰキー
			 "KEY_PGDN"		 : D_DIK_PGDN,			/// ＰａｇｅＤｏｗｎキー
			 "KEY_END	"		 : D_DIK_END,				/// エンドキー
			 "KEY_HOME"		 : D_DIK_HOME,			/// ホームキー
			 "KEY_LEFT"		 : D_DIK_LEFT,			/// 左キー
			 "KEY_UP"			 : D_DIK_UP,				/// 上キー
			 "KEY_RIGHT"	 : D_DIK_RIGHT,			/// 右キー
			 "KEY_DOWN"		 : D_DIK_DOWN,			/// 下キー
			 "KEY_INSERT"	 : D_DIK_INSERT,		/// インサートキー
			 "KEY_DELETE"	 : D_DIK_DELETE,		/// デリートキー

			 "KEY_MINUS"		 : D_DIK_MINUS,			/// －キー
			 "KEY_YEN"			 : D_DIK_YEN,				/// ￥キー
			 "KEY_PREVTRACK" : D_DIK_PREVTRACK,	/// ＾キー
			 "KEY_PERIOD"		 : D_DIK_PERIOD,		/// ．キー
			 "KEY_SLASH"		 : D_DIK_SLASH,			/// ／キー
			 "KEY_LALT"			 : D_DIK_LALT,			/// 左ＡＬＴキー
			 "KEY_RALT"			 : D_DIK_RALT,			/// 右ＡＬＴキー
			 "KEY_SCROLL"		 : D_DIK_SCROLL,		/// ScrollLockキー
			 "KEY_SEMICOLON" : D_DIK_SEMICOLON,	/// ；キー
			 "KEY_COLON"		 : D_DIK_COLON,			/// ：キー
			 "KEY_LBRACKET"	 : D_DIK_LBRACKET,	/// ［キー
			 "KEY_RBRACKET"	 : D_DIK_RBRACKET,	/// ］キー
			 "KEY_AT"				 : D_DIK_AT,				/// ＠キー
			 "KEY_BACKSLASH" : D_DIK_BACKSLASH,	/// ＼キー
			 "KEY_COMMA"		 : D_DIK_COMMA,			/// ，キー
			 "KEY_KANJI"		 : D_DIK_KANJI,			/// 漢字キー
			 "KEY_CONVERT"	 : D_DIK_CONVERT,		/// 変換キー
			 "KEY_NOCONVERT" : D_DIK_NOCONVERT,	/// 無変換キー
			 "KEY_KANA"			 : D_DIK_KANA,			/// カナキー
			 "KEY_APPS"			 : D_DIK_APPS,			/// アプリケーションメニューキー
			 "KEY_CAPSLOCK"	 : D_DIK_CAPSLOCK,	/// CaspLockキー
			 "KEY_SYSRQ"		 : D_DIK_SYSRQ,			/// PrintScreenキー
			 "KEY_PAUSE"		 : D_DIK_PAUSE,			/// PauseBreakキー
			 "KEY_LWIN"			 : D_DIK_LWIN,			/// 左Ｗｉｎキー
			 "KEY_RWIN"			 : D_DIK_RWIN,			/// 右Ｗｉｎキー

			 "KEY_NUMLOCK"		 : D_DIK_NUMLOCK,			/// テンキー０
			 "KEY_NUMPAD0"		 : D_DIK_NUMPAD0,			/// テンキー０
			 "KEY_NUMPAD1"		 : D_DIK_NUMPAD1,			/// テンキー１
			 "KEY_NUMPAD2"		 : D_DIK_NUMPAD2,			/// テンキー２
			 "KEY_NUMPAD3"		 : D_DIK_NUMPAD3,			/// テンキー３
			 "KEY_NUMPAD4"		 : D_DIK_NUMPAD4,			/// テンキー４
			 "KEY_NUMPAD5"		 : D_DIK_NUMPAD5,			/// テンキー５
			 "KEY_NUMPAD6"		 : D_DIK_NUMPAD6,			/// テンキー６
			 "KEY_NUMPAD7"		 : D_DIK_NUMPAD7,			/// テンキー７
			 "KEY_NUMPAD8"		 : D_DIK_NUMPAD8,			/// テンキー８
			 "KEY_NUMPAD9"		 : D_DIK_NUMPAD9,			/// テンキー９
			 "KEY_MULTIPLY"	 	 : D_DIK_MULTIPLY,		/// テンキー＊キー
			 "KEY_ADD"				 : D_DIK_ADD,					/// テンキー＋キー
			 "KEY_SUBTRACT"	 	 : D_DIK_SUBTRACT,		/// テンキー－キー
			 "KEY_DECIMAL"		 : D_DIK_DECIMAL,			/// テンキー．キー
			 "KEY_DIVIDE"			 : D_DIK_DIVIDE,			/// テンキー／キー
			 "KEY_NUMPADENTER" : D_DIK_NUMPADENTER,	/// テンキーのエンターキー

			 "KEY_F1"	: D_DIK_F1,	 /// Ｆ１キー
			 "KEY_F2"	: D_DIK_F2,	 /// Ｆ２キー
			 "KEY_F3"	: D_DIK_F3,	 /// Ｆ３キー
			 "KEY_F4"	: D_DIK_F4,	 /// Ｆ４キー
			 "KEY_F5"	: D_DIK_F5,	 /// Ｆ５キー
			 "KEY_F6"	: D_DIK_F6,	 /// Ｆ６キー
			 "KEY_F7"	: D_DIK_F7,	 /// Ｆ７キー
			 "KEY_F8"	: D_DIK_F8,	 /// Ｆ８キー
			 "KEY_F9"	: D_DIK_F9,	 /// Ｆ９キー
			 "KEY_F10" : D_DIK_F10,	/// Ｆ１０キー
			 "KEY_F11" : D_DIK_F11,	/// Ｆ１１キー
			 "KEY_F12" : D_DIK_F12,	/// Ｆ１２キー

			 "KEY_A" : D_DIK_A,	/// Ａキー
			 "KEY_B" : D_DIK_B,	/// Ｂキー
			 "KEY_C" : D_DIK_C,	/// Ｃキー
			 "KEY_D" : D_DIK_D,	/// Ｄキー
			 "KEY_E" : D_DIK_E,	/// Ｅキー
			 "KEY_F" : D_DIK_F,	/// Ｆキー
			 "KEY_G" : D_DIK_G,	/// Ｇキー
			 "KEY_H" : D_DIK_H,	/// Ｈキー
			 "KEY_I" : D_DIK_I,	/// Ｉキー
			 "KEY_J" : D_DIK_J,	/// Ｊキー
			 "KEY_K" : D_DIK_K,	/// Ｋキー
			 "KEY_L" : D_DIK_L,	/// Ｌキー
			 "KEY_M" : D_DIK_M,	/// Ｍキー
			 "KEY_N" : D_DIK_N,	/// Ｎキー
			 "KEY_O" : D_DIK_O,	/// Ｏキー
			 "KEY_P" : D_DIK_P,	/// Ｐキー
			 "KEY_Q" : D_DIK_Q,	/// Ｑキー
			 "KEY_R" : D_DIK_R,	/// Ｒキー
			 "KEY_S" : D_DIK_S,	/// Ｓキー
			 "KEY_T" : D_DIK_T,	/// Ｔキー
			 "KEY_U" : D_DIK_U,	/// Ｕキー
			 "KEY_V" : D_DIK_V,	/// Ｖキー
			 "KEY_W" : D_DIK_W,	/// Ｗキー
			 "KEY_X" : D_DIK_X,	/// Ｘキー
			 "KEY_Y" : D_DIK_Y,	/// Ｙキー
			 "KEY_Z" : D_DIK_Z,	/// Ｚキー

			 "KEY_0" : D_DIK_0,	/// ０キー
			 "KEY_1" : D_DIK_1,	/// １キー
			 "KEY_2" : D_DIK_2,	/// ２キー
			 "KEY_3" : D_DIK_3,	/// ３キー
			 "KEY_4" : D_DIK_4,	/// ４キー
			 "KEY_5" : D_DIK_5,	/// ５キー
			 "KEY_6" : D_DIK_6,	/// ６キー
			 "KEY_7" : D_DIK_7,	/// ７キー
			 "KEY_8" : D_DIK_8,	/// ８キー
			 "KEY_9" : D_DIK_9,	/// ９キー
		];
		NameTable = NameTable.rehash;
	}
	int search(string KeyName){
		return NameTable.get(KeyName,-1);
	}
}
public enum _KeyMap_max = 64;
class KeyConfig{
static :
	KeyMap[_KeyMap_max] keymap;		//キーマップ

	string KeyName;
	private uint KeyId;

	private char[] buf;
	private int ibuf;
	private int CurLine;
	private int KeyMapNum;		// 登録したキーマップの数
	//キーマップのロード
	//返値	負:失敗、エラーの行数
	//			正:成功、登録した数
	int LoadKeyMap(string filename){
		auto KeyMapFile = File(filename);
		CurLine = 0;		//現在読み込んでいる行
		KeyMapNum = 0;
		while(KeyMapFile.readln(buf)){
			CurLine++;
			if (KeyMapNum > _KeyMap_max) return -CurLine;		//登録数が限界まで登録した時
			buf = removechars(buf.idup," |\t|\r|\n").dup;		//tab,スペースの除去
			if (CurLine == 1) {		//1行目ならBOM処理が必要
				if ((buf[0] == 239)&&(buf[1] == 187)&&(buf[2] == 191)) buf = buf[3 .. $].dup;		//最初の三つがBOMなら消す。utf-8以外は考えない
			}
			if (buf.length == 0) continue;		//からっぽなら戻る
			/+
			foreach(CurChar; buf){
				write(cast(int)(CurChar)," "); 
			}
			writeln();
			+/
			if (buf[0 .. 2] == "//") continue;		//コメント読み飛ばし
			if (buf[0] == ';') continue;

			if (buf == "END") break;		//ENDを見つけたらそこで終わり
			ibuf = buf.indexOf('=');
			if (ibuf == -1) return -CurLine;
			KeyName = buf[0 .. ibuf].idup;		//キー名
			KeyId = KeyTable.search(KeyName);
			if (KeyId == -1) return -CurLine ;		//リストにないKeyId
			keymap[KeyMapNum].KeyId = KeyId;
			keymap[KeyMapNum].Stroke = buf[ibuf+1 .. $].idup;		//ストローク定義
			//writeln(KeyName,"(",KeyId,") : ",keymap[KeyMapNum].Stroke);
			KeyMapNum++;
		}
		return KeyMapNum;
	}
	//KeyMapNum番のKeyIdを得る
	int keyid(int KeyMapNum){
		return keymap[KeyMapNum].KeyId;
	}
	//KeyMapNum番のStrokeを得る
	string stroke(int KeyMapNum){
		return keymap[KeyMapNum].Stroke;
	}
}
//キーマップ型
struct KeyMap{
	//--基本操作;テンキー通り
	//5		process
	//2		catch
	//963	pop(0)~(2)
	//741	push(0)~(2)
	//--特殊操作
	//H	Help
	//N	NewGame
	//Q	Quit
	//R	Reset
	int KeyId;					//キーID
	string Stroke;		//ストローク(実際の動作の定義)
}
/*
void main (){
	new KeyTable;
	writeln(KeyConfig.LoadKeyMap("KeyMap.txt"));
}
*/
